$(function(){
    var
        currentSite = 'main',
        live_evt_types = {
            'hir': {
                'title': 'Új esemény',
                'icon': 'uj_hir.png'
            },
            'rajt': {
                'title': 'Rajt',
                'icon': 'rajt.png'
            },
            'zold_zaszlo': {
                'title': 'Zöld zászló',
                'icon': 'zold_zaszlo.png'
            },
            'sarga_zaszlo': {
                'title': 'Sárga zászló',
                'icon': 'sarga_zaszlo.png'
            },
            'piros_zaszlo': {
                'title': 'Piros zászló',
                'icon': 'piros_zaszlo.png'
            },
            'kockas_zaszlo': {
                'title': 'Kockás zászló',
                'icon': 'kockas_zaszlo.png'
            },
            'utkozes': {
                'title': 'Ütközés',
                'icon': 'utkozes.png'
            },
            'megprordules': {
                'title': 'Megpördülés',
                'icon': 'megpordules.png'
            },
            'kicsuszas': {
                'title': 'Kicsúszás',
                'icon': 'kicsuszas.png'
            },
            'biztonsagi_auto': {
                'title': 'Biztonsági autó',
                'icon': 'biztonsagi_auto.png'
            },
            'elozes': {
                'title': 'Előzés',
                'icon': 'elozes.png'
            },
            'muszaki_hiba': {
                'title': 'Műszaki hiba',
                'icon': 'muszaki_hiba.png'
            },
            'fontos_fejlesztes': {
                'title': 'Fontos fejlesztés',
                'icon': 'fontos_fejlesztes.png'
            },
            'team_radio': {
                'title': 'Csapat Rádio',
                'icon': 'team_radiov2.png'
            },
            'idojaras': {
                'title': 'Időjárás',
                'icon': 'idojaras.png'
            },
            'kek_zaszlo': {
                'title': 'Kék zászló',
                'icon': 'kek_zaszlo.png'
            },
            'feher_zaszlo': {
                'title': 'Fehér zászló',
                'icon': 'feher_zaszlo.png'
            },
            'csuszos_palya': {
                'title': 'Csúszós pálya',
                'icon': 'csuszos_palya.png'
            },
            'ido_esos': {
                'title': 'Esős idő',
                'icon': 'ido_esos.png'
            },
            'ido_napos': {
                'title': 'Napos idő',
                'icon': 'ido_napos.png'
            },
            'ido_borult': {
                'title': 'Borult idő',
                'icon': 'ido_borul.png'
            },
            'ido_kodos': {
                'title': 'Ködös idő',
                'icon': 'ido_kodos.png'
            },
            'ido_felhosna': {
                'title': 'Felhős napos idő',
                'icon': 'ido_felhos_napos.png'
            },
            'offtopic': {
                'title': 'Offtopic',
                'icon': 'off.png'
            },
            'nyilatkozat': {
                'title': 'Nyilatkozat',
                'icon': 'team_radio.png'
            },
            'ferrari': {
                'title': 'Ferrari',
                'icon': 'team_ferrari.png'
            },
            'redbull': {
                'title': 'Red Bull',
                'icon': 'team_redbull.png'
            },
            'mercedes': {
                'title': 'Mercedes',
                'icon': 'team_mercedes.png'
            },
            'lotus': {
                'title': 'Lotus',
                'icon': 'team_lotus.png'
            },
            'sauber': {
                'title': 'Sauber',
                'icon': 'team_sauber.png'
            },
            'williams': {
                'title': 'Williams',
                'icon': 'team_williams.png'
            },
            'str': {
                'title': 'Toro Rosso',
                'icon': 'team_toro.png'
            },
            'caterham': {
                'title': 'Caterham',
                'icon': 'team_caterham.png'
            },
            'marussia': {
                'title': 'Marussia',
                'icon': 'team_marussia.png'
            },
            'mclaren': {
                'title': 'McLaren',
                'icon': 'team_mclaren.png'
            },
            'india': {
                'title': 'Force India',
                'icon': 'team_india.png'
            },
            'gergo': {
                'title': 'Gergő',
                'icon': 'gergo.png'
            },
            'david': {
                'title': 'Dávid',
                'icon': 'david.png'
            }
        }
        liveSocket = null,
        liveSocketInterval = null,
        killSockets = function() {
            if (!$('body').pagecontainer('getActivePage').is('#live-list')) {
                if (liveSocketInterval !== null) {
                    clearInterval(liveSocketInterval)
                }
            }
        },
        category_filter = false,
        tag_filter = false,
        templates = {
            live_template: _.template($('#live_template').text()),
            article_lead_template: _.template($('#article_lead_template').text()),
            article_template: _.template($('#article_template').text()),
            live_article_template: _.template($('#live_article_template').text()),
            article_single_template: _.template($('#article_single_template').text()),
            tabella_racer_template: _.template($('#tabella_racer_template').text()),
            tabella_team_template: _.template($('#tabella_team_template').text()),
            tabella_race_template: _.template($('#tabella_race_template').text()),
            live_event_template: _.template($('#live_event_template').text())
        };

    $("[data-role='header']").toolbar();
    $("[data-role='navbar']").navbar();

    $('body').on('swipeleft', function() {
        var nextTab = $('body').pagecontainer('getActivePage').next();

        if (nextTab.is('#main, #auto, #tech')) {
            $('body').pagecontainer('change', '#' + nextTab.attr('id'));
        }

        killSockets();
    }).on('swiperight', function() {
        var thisTab = $('body').pagecontainer('getActivePage'),
            nextTab = thisTab.prev();

        if (thisTab.is('#live-list, #single-article, #filtered-list')) {
            history.go(-1);
        } else {
            $('body').pagecontainer('change', '#' + nextTab.attr('id'));
        }
        
        killSockets();
    })
    
    $(window).hashchange(function() {
        var hash = location.hash;

        if (['#main', '#auto', '#tech'].indexOf(hash) != -1) {
            currentSite = hash.slice(1);
            loadNews(true);
        }
        
        // Iterate over all nav links, setting the "selected" class as-appropriate.
        $("[data-role='navbar'] a").each(function() {
            var that = $(this);
            that[(that.attr("href") === ("#" + currentSite) || that.attr("href") === hash) ? "addClass" : "removeClass"]("ui-btn-active");
        });

        if ((hash == '#tabella') || (hash == '#naptar')) {
            $('#tabella [href="#main"], #naptar [href="#main"]').removeClass('ui-btn-active')
        }

        killSockets();
    }).hashchange();

    $('body').pagecontainer({
        change: function(event, ui) {
            var hash = '#' + ui.toPage.attr('id');

            // Iterate over all nav links, setting the "selected" class as-appropriate.
            $("[data-role='navbar'] a").each(function() {
                var that = $(this);
                that[(that.attr("href") === ("#" + currentSite) || that.attr("href") === hash) ? "addClass" : "removeClass"]("ui-btn-active");
            });

            if ((hash == '#tabella') || (hash == '#naptar')) {
                $('#tabella [href="#main"], #naptar [href="#main"]').removeClass('ui-btn-active')
            }

            killSockets();
        }
    });

    $('body').pagecontainer('change', '#main');
    $(window).on('scrollstop', function(e){
        console.log(e);
        if(
            $(window).scrollTop() > $(document).height() - ($(window).height() * 1.5)
            && ($('body').pagecontainer('getActivePage').is('#main, #tech, #auto') || 
                ($('body').pagecontainer('getActivePage').is('#filtered-list') && (
                    tag_filter != false || category_filter != false))
            )
        ) {
            loadNextPage();
        }
    })

    setInterval(loadNews, 30000)

    $('body').on('click', '#refresh-button', function(e){
        e.preventDefault()

        loadNews();
    })
    $('body').on('click', 'a[target="_system"]', function(e){
        e.preventDefault()

        window.open($(this).attr('href'), '_system');
    })

    function loadNews (initial) {
        checkForUpdate(GPLiveConfig.latestJson, function(has_update) {
            var responseHandler = function(response) {                
                $.each(response, function(i, article) {
                    renderArticle(article, 'top');
                })

                $('#all_articles_' + currentSite +' .article:has(.breaking)').prependTo('#all_articles_' + currentSite)
            }

            if (has_update) {
                loadFileFromServer(GPLiveConfig.latestJson).done(responseHandler);
            } else {
                if (initial) {
                    loadFileFromCache(GPLiveConfig.latestJson).done(responseHandler)
                }
            }
        });
    }

    function loadTabella (initial) {
        checkForUpdate(GPLiveConfig.tabellaJson, function(has_update) {
            var responseHandler = function(response) {
                    var racerTemplate = templates.tabella_racer_template,
                        teamTemplate = templates.tabella_team_template,
                        raceTemplate = templates.tabella_race_template;

                    $('#tabella-racers, #tabella-teams, #tabella-races').html('');

                    $.each(response.racers, function(i, racer) {
                        $('#tabella-racers').append(racerTemplate(_(racer).extend({tag: i})));
                    })
                    $.each(response.teams, function(i, team) {
                        $('#tabella-teams').append(teamTemplate(_(team).extend({tag: i})));
                    })

                    // TODO: versenynaptár felirat
                    $.each(response.races.races, function(i, race) {
                        $('#tabella-races').append(raceTemplate(_(race).extend({tag: i})));
                    })

                    $('#tabella-racers, #tabella-teams, #tabella-races').listview('refresh');
                }

            if (has_update) {
                loadFileFromServer(GPLiveConfig.tabellaJson).done(responseHandler);
            } else {
                if (initial) {
                    loadFileFromCache(GPLiveConfig.tabellaJson).done(responseHandler);
                }
            }
        });
    }

    function loadLive (initial) {
        if (GPLiveConfig.useLiveServer) {
            $('<script type="text/javascript" src="http://' + GPLiveConfig.liveServer + ':8080/socket.io/socket.io.js"></script>')
                .appendTo('head');
            $('<script type="text/javascript" src="http://' + GPLiveConfig.liveServer + '/node/client/livesteam.js"></script>')
                .appendTo('head');
        }

        checkForUpdate(GPLiveConfig.liveJson, function(has_update) {
            var responseHandler = function(response) {
                    var liveTemplate = $('#live_template').text();

                    console.log(response)

                    $('#live-articles').html('');

                    $.each(response, function(i, live) {
                        var $template = $(
                            $('#live_article_template').text()
                                .replace(/%title%/g, live.title)
                            ).click(function(){
                                window.liveUpdate.liveStream(live.id, GPLiveConfig.useLiveServer)
                            });

                        $template.appendTo('#live-articles');
                    })
                }

            if (has_update) {
                loadFileFromServer(GPLiveConfig.liveJson).done(responseHandler);
            } else {
                if (initial) {
                    loadFileFromCache(GPLiveConfig.liveJson).done(responseHandler);
                }
            }
        });
    }
    function checkForUpdate (file, callback) {
        if (file.indexOf('?') == -1 || !window.localStorage.getItem('last_modified_' + file + [currentSite])) {
            callback(true);
        }

        $.ajax({
            url: GPLiveConfig.serverBaseUrl[currentSite] + file,
            type: 'HEAD',
            cache: false,
            complete: function(jqXHR) {
                var result = new Date(window.localStorage.getItem('last_modified_' + file + [currentSite])) < new Date(jqXHR.getResponseHeader('Last-Modified'));

                console.log('checkForUpdate', file, result);

                callback(result)
            }
        });
    }

    function loadFileFromServer (file) {
        console.log('loadFileFromServer', file);

        if (typeof GPLiveConfig.serverBaseUrl[currentSite] == 'undefined') {
            return {
                done: function(callback) {
                    callback({})
                }
            }
        }

        $.mobile.loading('show');

        return $.ajax({
            url: GPLiveConfig.serverBaseUrl[currentSite] + file,
            dataType: 'json',
            complete: function(jqXHR) {
                $.mobile.loading('hide');

                if (file.indexOf('?') == -1) {
                    window.localStorage.setItem('last_modified_' + file + [currentSite], jqXHR.getResponseHeader('Last-Modified'))
                    window.localStorage.setItem('last_version_' + file + [currentSite], jqXHR.responseText)
                }
            }
        })
    }

    function loadFileFromCache (file) {
        var response = window.localStorage.getItem('last_version_' + file + [location.hash.slice(1)])

        console.log('loadFileFromCache', file);

        return {
            done: function(callback) {
                callback(JSON.parse(response))
            }
        }
    }

    function renderArticle (article, position, slider) {

        var singular = false

        if (typeof slider == 'undefined' || slider == 'all_articles') {
            slider = 'all_articles_' + location.hash.slice(1);
        }

        if (slider == 'single_article') {
            singular = true;
        }

        var sliderTab = $('#' + slider);

        if ($('#' + slider + '_article_' + article.id).length == 0) {
            var template = function(){};

            if (article.content.indexOf('[live_event') != -1) {
                var lives = article.content.match(/\[live_event id="(.*?)"\]/gi);

                $.each(lives, function(i, e) {
                    var id = e.replace('[live_event id="', "").replace('"]', ""),
                        link = '<hr/><a href="#" onclick="window.liveUpdate.liveStream(' 
                            + id + ', ' 
                            + GPLiveConfig.useLiveServer 
                            + ',\'' + article.title + '\',\'' + article.category_slug + '\',' 
                            +'\'' + article.category + '\')">ÉLŐ KÖZVETÍTÉS</a><hr/>';

                    article.content = article.content.replace(e, link);
                })
            }

            if (singular) {
                template = templates.article_single_template
            } else if (
                (
                    article.current_featured 
                    || (Math.random() > 0.5)
                    || (sliderTab.find('.article').length == 19)
                )
                && typeof article.image != 'undefined'){        
                template = templates.article_lead_template
            } else {
                template = templates.article_template
            }

            var $template = $(template(article));

            $template.attr('id', slider + '_article_' + article.id);

            if (!singular) {
                $template.on('click', function (e) {
                    if (!$(e.target).is('a')) {
                        openArticle(article)
                    }
                })
            }

            if(!article.current_adult){
                if (position == 'top') {
                    $template.prependTo(sliderTab);
                } else {
                    $template.appendTo(sliderTab);
                }
            }   

            if (singular) {

                ga('send', 'pageview', {'page': article.permalink,'title':article.title });     
                console.log('pageview');

                if (article.current_gallery) {
                    var pswpElement = $('.pswp')[0],
                        items = article.gallery_images,
                        options = {
                            index: 0 // start at first slide
                        },
                        gallery = new PhotoSwipe( pswpElement, PhotoSwipeUI_Default, items, options);

                    sliderTab
                        .append('<a class="gallery-link">Tovább a galériához <i class="fa fa-camera"></i></a>')
                        .find('a:last').click(function(){
                            gallery.init();
                        })
                }

                sliderTab.append('<h4 class="ui-body ui-corner-all ui-body-a tagline"><span>Olvastad már?</span></h4>')
                loadFileFromServer(GPLiveConfig.update + '?related_to=' + article.id).done(function(response) {
                    $.each(response, function(i, article) {
                        var $template = $(templates.article_template(article));

                        $template.attr('id', 'related_article_' + article.id);
                        $template.on('click', function (e) {
                            if (!$(e.target).is('a')) {
                                openArticle(article)
                            }
                        })

                        $template.appendTo(sliderTab);
                    })
                });
            }
        }
    }

    function openArticle (article) {

        show_interstitial();

        if (GPLiveConfig.articleOpener == 'slider') {
            
            hash = location.hash.slice(1)
            
            window.liveUpdate.renderArticle(article)

            $('#single_article').attr('class', 'ui-content').addClass(hash);
        } else if (GPLiveConfig.articleOpener == 'inappbrowser') {
            window.open(article.permalink, '_system');
        } else if (GPLiveConfig.articleOpener == 'ajaxget') {
            paginatorActive = false;

            $('body > div').hide();

            $('<div id="article"></div>').appendTo('body');

            $.ajax({
                url: article.permalink + '?app=1',
                success: function(resp) {
                    $('#article').html(resp)
                }
            });

            document.addEventListener("backbutton", function(e) {
                e.preventDefault();
                document.removeEventListener("backbutton", arguments.callee, false);

                $('#article').remove();
                $('body > div').show();

                paginatorActive = false;

            }, false);
        }
    }

    function clearArticles (slider) {
        if (typeof slider == 'undefined') {
            slider = 'all_articles_' + location.hash.slice(1);
        }

        $('#' + slider).html('')
    }

    function loadNextPage() {
        var 
            toLoad = GPLiveConfig.update,
            parts = [],
            slider = 'all_articles_' + location.hash.slice(1),
            responseHandler = function(response) {
                $.each(response, function(i, article) {
                    renderArticle(article, 'bottom', slider);
                })
            };

        if (category_filter != false) {
            slider = 'filtered_articles';
            parts.push('category=' + category_filter);
        }

        if (tag_filter != false) {
            slider = 'filtered_articles';
            parts.push('tag=' + tag_filter);
        }

        // TODO lastpage
        if ($('#' + slider).find('.article').length) {
            last = $('#' + slider).find('.article:last').attr('id').replace(slider + '_article_', '')

            parts.push('last=' + last)
        }

        loadFileFromServer(toLoad + '?' + parts.join('&')).done(responseHandler);
    }

    window.liveUpdate = {
        backToAllNews: function (tab) {
            if (typeof tab == 'undefined') {
                tab = 'main'
            }
            //clearArticles();

            //loadNews(true)

            $('body').pagecontainer('change', '#' + tab);
        },
        renderArticle: function (article) {
            clearArticles('single_article');

            window.scrollTo(0, 0)

            renderArticle(article, 'top', 'single_article');

            $('body').pagecontainer('change', '#single-article');
        },
        loadCategory: function(category_slug, title) {
            category_filter = category_slug;
            tag_filter = false;

            clearArticles('filtered_articles');

            loadNextPage();

            $('#filtered_articles').prepend('<h1 class="ui-body ui-corner-all ui-body-a filtered-list">' + title + '</h1>');

            $('body').pagecontainer('change', '#filtered-list');
        },
        loadTag: function(tag_slug, title) {
            tag_filter = tag_slug;
            category_filter = false;

            clearArticles('filtered_articles');

            loadNextPage();

            $('#filtered_articles').prepend('<h1 class="ui-body ui-corner-all ui-body-a">' + title + '</h1>');
            
            $('body').pagecontainer('change', '#filtered-list');
        },
        resetFilter: function() {
            category_filter = false;
            tag_filter = false;
        },
        liveStream: function(id, isLiveUpdate, article_title, article_category_slug, article_category) {
            var drawData = function(data) {
                liveEventTemplate = templates.live_event_template;

                if (data.deleted == 1) {
                    $('#le_e_' + data.id).hide('slow', function() {
                        $('#le_e_' + data.id).remove();
                    });
                } else if ($('#le_e_' + data.id).length == 1) {
                    liveEventTemplate = liveEventTemplate({
                        id: data.id,
                        serverBaseUrl: GPLiveConfig.serverBaseUrl[currentSite],
                        icon: live_evt_types[data.type].icon,
                        type_title: live_evt_types[data.type].title,
                        time: (data.time_type != 'id\u0151pont' ? data.time + '.' : data.time),
                        time_type: (data.time_type != 'id\u0151pont' ? data.time_type : ''),
                        content: data.content
                    })

                    $('#le_e_' + data.id).replaceWith(liveEventTemplate);

                } else {
                    var $template = $(
                        liveEventTemplate({
                            id: data.id,
                            serverBaseUrl: GPLiveConfig.serverBaseUrl[currentSite],
                            icon: live_evt_types[data.type].icon,
                            type_title: live_evt_types[data.type].title,
                            time: (data.time_type != 'id\u0151pont' ? data.time + '.' : data.time),
                            time_type: (data.time_type != 'id\u0151pont' ? data.time_type : ''),
                            content: data.content
                        })
                    )

                    $template.prependTo('#live_list_articles');
                }
            },
            ajaxUpdate = function(lastupd, successCallback) {
                $.ajax({
                    url: GPLiveConfig.serverBaseUrl[currentSite]  + 'live_stream.php',
                    data: {
                        lastupd: lastupd,
                        live: id
                    },
                    success: function(data) {
                        console.log(data);

                        data = data.data.data

                        for (i in data) {
                            drawData(data[i]);
                        }

                        if (typeof successCallback != 'undefined') {
                            successCallback.call();
                        }
                    }
                });
            }

            if (isLiveUpdate) {
                liveSocket = liveSteamListener(id, function(data) {
                    drawData(data);
                }, GPLiveConfig.liveServer).connect();
            } else {
                var lastUpd = 0,
                    completed = true,
                    a = function() {
                        if (completed) {
                            var lastUpd2 = lastUpd;

                            lastUpd = Date.now() / 1000;
                            completed = false;

                            ajaxUpdate(lastUpd2, function() {
                                completed = true;
                            });
                        }
                    }

                liveSocketInterval = setInterval(a, 12000);

                a();
            }

            $('#live_list_articles, #live_header').html('');

            if (typeof article_title != 'undefined') {
                $('#live_header').append(templates.article_template({
                    type: 'post',
                    current_live: true,
                    breaking_news: false,
                    category_slug: article_category_slug,
                    category: article_category,
                    date: 'Folyamatosan frissül',
                    title: article_title
                }));
            }

            $('body').pagecontainer('change', '#live-list')

        }
    }

    
    loadNews(true);
    loadTabella(true);
    //loadLive(true);
    clearArticles();

})